from shiny import module, ui, render, Inputs, Outputs, Session

from sklearn.decomposition import NMF
from src.data_loader import tweet_store

classes = 10

# Fit the NMF model
nmf = NMF(
    n_components=classes,
    random_state=42,
    init=None,
    beta_loss="frobenius",
    alpha_W=0.0,
    alpha_H="same",
    l1_ratio=0.0,
).fit(tweet_store.tfidf_matrix)


# TODO: dont do this live -> load the feature_names and values from a pre-calculated list for each day
tfidf_feature_names = tweet_store.tfidf_vectorizer.get_feature_names_out()
print(tfidf_feature_names)


@ module.ui
def topics_ui():
    return ui.div(
        ui.h2("Tweet Topics"),
    )


@ module.server
def topics_server(input: Inputs, output: Outputs, session: Session):
    @ output
    @ render.ui
    def searchable_tweet_ui():
        pass
